"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "salt", {
    enumerable: true,
    get: ()=>salt
});
const _path = /*#__PURE__*/ _interopRequireWildcard(require("path"));
const _crypto = /*#__PURE__*/ _interopRequireWildcard(require("crypto"));
const _fastGlob = /*#__PURE__*/ _interopRequireWildcard(require("fast-glob"));
const _fs = /*#__PURE__*/ _interopRequireWildcard(require("fs"));
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
let envHash;
function salt(environmentGlobFiles, command, repoRoot, customKey = "") {
    return hashStrings([
        ...getEnvHash(environmentGlobFiles, repoRoot),
        command,
        customKey
    ]);
}
function getEnvHash(environmentGlobFiles, repoRoot) {
    if (!envHash) {
        const newline = /\r\n|\r|\n/g;
        const LF = "\n";
        const files = _fastGlob.sync(environmentGlobFiles, {
            cwd: repoRoot
        });
        files.sort((a, b)=>a.localeCompare(b));
        const hashes = files.map((file)=>{
            const hasher = _crypto.createHash("sha1");
            hasher.update(file);
            const fileBuffer = _fs.readFileSync(_path.join(repoRoot, file));
            const data = fileBuffer.toString().replace(newline, LF);
            hasher.update(data);
            return hasher.digest("hex");
        });
        envHash = hashes;
    }
    return envHash;
}
function hashStrings(strings) {
    const hasher = _crypto.createHash("sha1");
    const anArray = typeof strings === "string" ? [
        strings
    ] : strings;
    const elements = [
        ...anArray
    ];
    elements.sort((a, b)=>a.localeCompare(b));
    elements.forEach((element)=>hasher.update(element));
    return hasher.digest("hex");
}
