"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "graph", {
    enumerable: true,
    get: ()=>graph
});
const _workspaceTools = require("workspace-tools");
async function graph(cwd) {
    const root = (0, _workspaceTools.getWorkspaceRoot)(cwd);
    if (!root) {
        throw new Error("This must be called inside a codebase that is part of a JavaScript workspace.");
    }
    const allPackages = (0, _workspaceTools.getPackageInfos)(root);
    const edges = (0, _workspaceTools.createPackageGraph)(allPackages, {
        namePatterns: [
            "@nova/types"
        ],
        includeDependencies: true,
        includeDependents: false
    });
    const fs = require("fs");
    let output = JSON.stringify(edges);
    fs.writeFileSync("types-dependents-false.js", output);
}
