"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "createContext", {
    enumerable: true,
    get: ()=>createContext
});
const _pProfiler = /*#__PURE__*/ _interopRequireDefault(require("p-profiler"));
const _path = require("path");
const _os = require("os");
const _fs = require("fs");
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function createContext(config) {
    const { concurrency , profile  } = config;
    const useCustomProfilePath = typeof profile === "string";
    const profilerOutputDir = useCustomProfilePath ? (0, _path.dirname)(profile) : (0, _path.join)((0, _os.tmpdir)(), "lage", "profiles");
    (0, _fs.mkdirSync)(profilerOutputDir, {
        recursive: true
    });
    const profiler = new _pProfiler.default(useCustomProfilePath ? {
        concurrency,
        customOutputPath: profile
    } : {
        concurrency,
        prefix: "lage",
        outDir: profilerOutputDir
    });
    return {
        measures: {
            start: [
                0,
                0
            ],
            duration: [
                0,
                0
            ],
            failedTargets: []
        },
        targets: new Map(),
        profiler
    };
}
