"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "TaskLogger", {
    enumerable: true,
    get: ()=>TaskLogger
});
const _logger = require("./Logger");
const _readline = require("readline");
class TaskLogger {
    log(level, msg, data) {
        this.logger.log(level, msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    info(msg, data) {
        this.logger.info(msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    warn(msg, data) {
        this.logger.warn(msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    error(msg, data) {
        this.logger.error(msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    verbose(msg, data) {
        this.logger.verbose(msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    silly(msg, data) {
        this.logger.silly(msg, {
            package: this.pkg,
            task: this.task,
            ...data
        });
    }
    stream(level, input, data) {
        const readline = (0, _readline.createInterface)({
            input,
            crlfDelay: Infinity
        });
        readline.on("line", (line)=>this.log(level, line, data));
    }
    getLogs() {
        return this.logger.logs;
    }
    constructor(pkg, task){
        this.pkg = pkg;
        this.task = task;
        this.logger = new _logger.Logger();
    }
}
