"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    findNpmClient: ()=>findNpmClient,
    findInPath: ()=>findInPath
});
const _path = /*#__PURE__*/ _interopRequireDefault(require("path"));
const _fs = /*#__PURE__*/ _interopRequireDefault(require("fs"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function findNpmClient(npmClient) {
    const found = findInPath(npmClient);
    if (!found) {
        throw new Error(`npm client not found: ${npmClient}`);
    }
    return found;
}
function findInPath(target) {
    const envPath = process.env.PATH ?? "";
    const pathExt = process.env.PATHEXT ?? "";
    for (const search of envPath.split(_path.default.delimiter)){
        const found = pathExt.split(_path.default.delimiter).map((ext)=>_path.default.join(search, `${target}${ext}`)).find((p)=>_fs.default.existsSync(p));
        if (found) {
            return found;
        }
    }
}
