"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "generateTopologicGraph", {
    enumerable: true,
    get: ()=>generateTopologicGraph
});
const _workspaceTools = require("workspace-tools");
const _path = /*#__PURE__*/ _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function generateTopologicGraph(workspace) {
    const graph = {};
    const dependentMap = (0, _workspaceTools.getDependentMap)(workspace.allPackages);
    for (const [pkg, info] of Object.entries(workspace.allPackages)){
        const deps = dependentMap.get(pkg);
        graph[pkg] = {
            dependencies: [
                ...deps ? deps : []
            ],
            location: _path.default.relative(workspace.root, _path.default.dirname(info.packageJsonPath))
        };
    }
    return graph;
}
