"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "getPackagePipelines", {
    enumerable: true,
    get: ()=>getPackagePipelines
});
const _cosmiconfig = require("cosmiconfig");
const _path = /*#__PURE__*/ _interopRequireDefault(require("path"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
const ConfigModuleName = "lage";
function getPipeline(info) {
    const results = (0, _cosmiconfig.cosmiconfigSync)(ConfigModuleName).search(_path.default.dirname(info.packageJsonPath));
    if (results && results.config) {
        return results.config.pipeline;
    }
    return null;
}
function getPackagePipelines(allPackages, defaultPipeline) {
    const packagePipelines = new Map();
    for (const pkg of Object.keys(allPackages)){
        const pipeline = getPipeline(allPackages[pkg]);
        if (pipeline) {
            packagePipelines.set(pkg, pipeline);
        } else {
            packagePipelines.set(pkg, defaultPipeline);
        }
    }
    return packagePipelines;
}
