"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "getWorkspace", {
    enumerable: true,
    get: ()=>getWorkspace
});
const _workspaceTools = require("workspace-tools");
const _findNpmClient = require("./findNpmClient");
function getWorkspace(cwd, config) {
    const root = (0, _workspaceTools.getWorkspaceRoot)(cwd);
    if (!root) {
        throw new Error("This must be called inside a codebase that is part of a JavaScript workspace.");
    }
    const { npmClient  } = config;
    const allPackages = (0, _workspaceTools.getPackageInfos)(root);
    const npmCmd = (0, _findNpmClient.findNpmClient)(npmClient);
    return {
        root,
        allPackages,
        npmClient,
        npmCmd
    };
}
